// Programa 2: uso de cmath, try-catch
// Fecha: 5/9/2019; 5:07 pm
// Revisin: 11/9/2020: 5:30 pm
// S. Galliano.

#include "secante.h"
#include <iostream>
#include <cstdlib>

inline bool fueraDeLimites( double valor ) {
    return ( valor < 0 ) or ( valor > 360 );
}

int main() {
    double valor;
    std::string sn; // una vez ms?
    std::cout << "Ejercicio 2: c\240lculo de la secante\n"
                 "con un error de  " << EPS << " grados alrededor de 90\n\n";

    while ( true ) {
        std::cout << "Valor entre 0 y 360 grados sexagesimales: ";
        std::cin  >> valor;

        if ( fueraDeLimites( valor ) ) {
            std::cout << '\n';
            continue;
        } // if

        if ( std::cin.fail() ) {
            std::cin.clear();
            while ( std::cin.get() not_eq '\n' ) continue;
            continue;
        } // if

        try {
            std::cout << "Secante = " << secante( valor ) << '\n';
        } catch ( std::string ) {
            std::cout << INFINITO;
        } // try-catch

        std::cout << "\n\250Una vez m\240s? (s/n)> ";
        std::cin >> sn;
        if ( 'N' == toupper( sn[0] ) ) return EXIT_SUCCESS;
    } // while
}
