#ifndef SECANTE_H_INCLUDED
#define SECANTE_H_INCLUDED

//  secante.h: definiciones para el problema 2
//  Fecha: 21/1/2020; 10:06 am
//  Por: S. Galliano.

const double EPS = 0.5;          // lmite del error
const double K = 3.141593 / 180; // pi / 180

#include <string>
const std::string INFINITO( "Infinito\n" );

// calcula la secante de un ngulo
// input: los grados sexagesimales
// output: el valor de la secante
double secante( double grads );

// funcin auxiliar: comprueba ambos lmites
// true si el valor cae dentro
bool enLimite( double grads );

#endif // SECANTE_H_INCLUDED
