// Programa 10: siega de Eratstenes
// Fecha: 13/9/2020; 1:18 pm
// S. Galliano

#include <vector>
#include <iostream>
#include <cstdlib>

int main() {
    using namespace std;
    cout << "Ejercicio 10: la siega de Erat\242stenes.\n\n";

    // crea una siega de booleanos puestos a true.
    int maxSiega, ctd = 0;
    cout << "\250Cu\240ntos n\243meros? ";
    cin >> maxSiega;
    vector<bool> siega( maxSiega, true );

    // la siega
    for (int i = 2; i * i < maxSiega; ++i) {
        if ( siega[i] ) {
            for (int j = i + i; j < maxSiega; j += i) {
                siega[j] = false;
            } // for
        } // if
    } // for

    cout << endl;

    for (int i = 2; i < maxSiega; ++i) {
        if ( siega[i]) {
            cout << i << ' ';
            ++ctd;
        } // if
    } // for

    cout << "\n\nSon " << ctd << " n\243meros primos.\n\n";
    system( "pause" );
    return EXIT_SUCCESS;
}

