//  Programa 11: mapas
//  Fecha: 13/9/2020; 1:30 pm
//  S. Galliano.

#include <map>
#include <iostream>
#include <string>

typedef std::string Str;
typedef std::multimap<Str, int> Meses;

int main() {
    using std::make_pair;
    std::cout << "Ejercio 11: los meses.\n";
    Meses mes;
    mes.insert( make_pair( "enero",      31 ) );
    mes.insert( make_pair( "febrero",    28 ) );
    mes.insert( make_pair( "marzo",      31 ) );
    mes.insert( make_pair( "abril",      30 ) );
    mes.insert( make_pair( "mayo",       31 ) );
    mes.insert( make_pair( "junio",      30 ) );
    mes.insert( make_pair( "julio",      31 ) );
    mes.insert( make_pair( "agosto",     31 ) );
    mes.insert( make_pair( "septiembre", 30 ) );
    mes.insert( make_pair( "octubre",    31 ) );
    mes.insert( make_pair( "noviembre",  30 ) );
    mes.insert( make_pair( "diciembre",  31 ) );

    // los das en un mes cualquiera
    Str miMes;

    do {
        std::cout << "\nPara salir entre una letra cualquiera.\nEntre un mes: ";
        getline( std::cin, miMes );

        Meses::iterator pos = mes.find( miMes );

        if( pos == mes.end() ) {
            return EXIT_SUCCESS;
        } else {
            std::cout << pos->first << " tiene " << pos->second << " d\241as.\n";
        } // if-else
    } while ( true ); // do-while
}
