
#include <algorithm>
#include <vector>
#include<iterator>
#include <functional>
#include <iostream>

using namespace std;

int main () {
    cout << "Problena 16: operaciones con el heap.\n";
    cout << "\nCrear 2 vectores ";
    vector<int> v1( 4 );
    iota( v1.begin(), v1.end(), 1 );
    vector<int> v2( v1 );
    reverse( v2.begin(), v2.end() );

    cout << "y hacerlos sendos heaps.\n";
    make_heap( v1.begin(), v1.end() );
    make_heap( v2.begin(), v2.end(), less<int>() );

    ostream_iterator<int, char, char_traits<char> > escribe( cout, " " );
    copy( v1.begin(), v1.end(), escribe ); cout << '\n';
    copy( v2.begin(), v2.end(), escribe ); cout << '\n';

    cout << "\nPopear ambos vectores.\n";
    pop_heap( v1.begin(), v1.end() );
    pop_heap( v2.begin(), v2.end(), less<int>() );

    copy( v1.begin(), v1.end(), escribe ); cout << '\n';
    copy( v2.begin(), v2.end(), escribe ); cout << '\n';

    cout << "\nPushear 9 y 7 respectivamente.\n";
    v1.push_back(9);
    push_heap( v1.begin(), v1.end());
    v2.push_back(7);
    push_heap( v2.begin(), v2.end(), less<int>() );

    copy( v1.begin(), v1.end(), escribe ); cout << '\n';
    copy( v2.begin(), v2.end(), escribe ); cout << '\n';

    cout << "\nY ahora, ordenarlos.\n";
    sort_heap( v1.begin(), v1.end() );
    sort_heap( v2.begin(), v2.end(), less<int>() );

    copy( v1.begin(), v1.end(), escribe ); cout << '\n';
    copy( v2.begin(), v2.end(), escribe ); cout << "\n\n";

    system("pause");
    return EXIT_SUCCESS;
}
