// Problema 17: uso del stack
// Fecha: 27/8/2019;m 7:56 am
// Revisin: 13/9/2020; 5:36 pm
// S. Galliano.

#include "menu.h"
#include <iostream>
#include <cstdlib>
#include <stack>

const Str ERROR( "\nError: pila vac\241a.\n\n" );

int main() {
    std::stack<int> pila;
    Str info( "Ejercicio 17: manejo de una pila de enteros.\n\n" );
    int n, valor;
    short opcion;

    while ( true ) {
        opcion = menu( info );

        if (Terminar == opcion) {
            return EXIT_SUCCESS;
        } else {
            n = pila.size();
        } // if-else

        switch ( opcion ) {
        case Apilar:
            std::cout << "\nEntre un entero: ";
            std::cin >> valor;
            pila.push( valor );
            std::cout << valor << " fue apilado.\n\n";
            break;
        case Contar:
            if ( pila.empty() ) {
                std::cout << ERROR;
            } else {
                1 == n
                    ? std::cout << "\nUn nodo.\n\n"
                    : std::cout << '\n' << n << " nodos.\n\n";
            } // if-else
            break;
        case Desapilar:
            if ( pila.empty() ) {
                std::cout << ERROR;
            } else {
                std::cout << '\n' << pila.top() << " fue desapilado.\n\n";
                pila.pop();
            } // if-else
            break;
        case Head:
            if ( pila.empty() ) {
                std::cout << ERROR;
            } else {
                std::cout << '\n' << pila.top() << " es el tope.\n\n";
            } // if-else
            break;
        } // switch

        system( "pause" );
    } // while
}
