//  clasifica.cpp: definiciones para el problema 8
//  Fecha: 6/9/2019; 7:28 am
//  Revisin: 1/4/2020; 10:55 pm
//  Por S. Galliano.

#include "clasifica.h"
#include <algorithm>

bool Triangulo::SiSePuede() {
    sort( ary.begin(), ary.end(), std::greater<double>() );
    return ary[0] != ( ary[1] + ary[2] );
}

#include <cmath>

bool Triangulo::esRecto() {
    return ( pow( ary[0], 2 ) ) == ( pow( ary[1], 2 ) + pow( ary[2], 2 ) );
}

#include <iostream>
using std::cout;

void Triangulo::Responder() {
    if ( SiSePuede() ) {
        cout << "\nSe puede hacer un tri\240ngulo";

        if ( esRecto() ) {
            cout << " rect\240ngulo.\n";
            cout << "  Hipotenusa = " << ary[0] << '\n';
            cout << "Cateto mayor = " << ary[1] << '\n';
            cout << "Cateto menor = " << ary[2] << "\n\n";
        } else {
            cout << ", pero no rect\240ngulo.\n";
            cout << "Lado mayor = " << ary[0] << '\n';
            cout << "Lado medio = " << ary[1] << '\n';
            cout << "Lado menor = " << ary[2] << "\n\n";
        } // if-else

    } else {
        cout << "\nNo se puede hacer un tri\240ngulo.\n\n";
    } // if-else
}

using std::cin;

void Triangulo::Entrar() {
    cout << "Lado 1 = ";
    cin >> ary[0];
    cout << "Lado 2 = ";
    cin >> ary[1];
    cout << "Lado 3 = ";
    cin >> ary[2];
}
