#ifndef GRAFICA_H_INCLUDED
#define GRAFICA_H_INCLUDED

//  grafica.h: definiciones para el problema 23
//  Fecha: 3/3/2020; 4:42 pm
//  Revisin: 13/8/2020; 6:17 am
//  Por: S. Galliano.

#include <string>
typedef std::string Str;
const Str ERROR( "Error: no pude abrir el fichero; abortando.\n\n" );

#include <tuple>
typedef std::tuple<float, int, Str> Valor;

#include <vector>
typedef std::vector<Valor> Dato;

//  carga el arreglo con los valores del fichero
//  input: el nombre del fichero
//  output: el arreglo est cargado
void cargar( Str bd, Dato & dat );

//  pone la grfica en consola
//  input: el arreglo
//  output la grfica
void graficar( const Dato & dat );

#endif // GRAFICA_H_INCLUDED
