//  menu.cpp: definiciones para el problema 25
//  Fecha: 7/4/2020; 11 pm
//  Revisin: 13/9/2020; 6:40 am
//  Por: S. Galliano.
#include "menu.h"
#include <iostream>
#include <cstdlib>
using std::string;

//  un men en consola
unsigned menu( string info ) {
    //  variables
    string conjunto = "01234567";
    string opcion;
    string::size_type idx;

    while ( true ) {
        system( "cls" );
        std::cout << info <<
		"1) Imprimir inventario\n"
        "2) Adicionar un producto\n"
        "3) Eliminar un producto\n"
        "4) Editar un precio\n"
        "5) Editar un stock\n"
        "6) Vaciar el inventario\n"
        "7) Pedir ayuda\n"
        "0) Terminar\n"
        "Seleccione una opci\242n: ";
        ( std::cin >> opcion ).get();
        idx = conjunto.find( opcion );

        if ( string::npos == idx ) {
            std::cerr << "\nError: opci\242n ilegal.\n\n";
            system( "pause" );
        } else {
            return idx;
        } // if-else
    } // while
}

//  la ayuda del men en consola
void ayuda ( string info ) {
    system( "cls" );
    std::cout << info << "AYUDA\n"
    "1) Adiciona un producto al inventario\n"
    "2) Cuenta los productos en inventario\n"
    "3) Elimina un producto del inventario\n"
    "4) Edita el precio de un producto\n"
    "5) Edita su cantidad en inventario\n"
    "6) Imprime el inventario en consola\n"
    "7) Vac\241a el inventario\n"
    "   Cuidado, esta operaci\242n es definitiva\n\n";
}
