/*
    Problema 27: vectores

    Descripcin: matemticamente hablando un vector plano es un par
    ordenado de valores. Rehacer el programa 5 utilizando la clase pair.
    Excepto por el encabezado, la salida debera verse igual.

    Hubo ganancia? Es decir, un cdigo ms simple, mayor abstraccin, etc.

    Fecha: 28/2/2020; 7 am
    Revisin: 4/4/2020; 11:32 am
    S. Galliano.
*/

#include "ppunto.h"
#include <iostream>
#include <cstdlib>
#include <iomanip>
#include <cmath>

const double RAD2GRAD = 45.0 / atan(1.0);
const int DEC    = 2;           // decimales

int main() {
    std::cout << "Ejercicio 27: c\240lculo del producto-punto de dos vectores\n\n";

    Vector A, B;
    A.entrar( "A" );
    B.entrar( "B" );

    std::cout << std::fixed << std::showpoint << std::setprecision( DEC ) << '\n';
    double pPto = A.pPunto( B );
    std::cout << "El producto-punto de A y B vale " << pPto << "\n\n";
    std::cout << "Norma de A = " << A.norma() << " u\n";
    std::cout << "Norma de B = " << B.norma() << " u\n";
    double sita = pPto / ( A.norma() * B.norma() );
    std::cout << "\nEl coseno entre A y B vale "  <<
    std::setprecision( DEC + 1 ) << sita << " rad o " <<
    std::setprecision( DEC )   << sita * RAD2GRAD << " grados.\n";

    if( 0 == sita ) std::cout << "A y B son perpendiculares.\n";
    else if( 1 == sita ) std::cout << "A y B son paralelos.\n";
    else if( -1 == sita ) std::cout << "A y B son anti-paralelos.\n\n";

    system( "pause" );
    return EXIT_SUCCESS;
}
