#ifndef PPUNTO_H_INCLUDED
#define PPUNTO_H_INCLUDED

//  ppunto.h: declaraciones para el problema 27
//  Fecha: 21/8/2019; 8:25 pm
//  Revisin: 4/4/2020; 11:32 am
//  Por S. Galliano.

#include <string>
typedef std::string Str;
typedef std::pair<double, double> Dueto;

//  un vector sabe como entrarse, mostrarse, calcular
//  su producto punto con otro vector y su norma
struct Vector {
    //  mtodos
    double pPunto( Vector B );
    void entrar( Str id );
    void mostrar( Str id );
    double norma();
    //  miembro
    Dueto duo;
};

#endif // VECTORES_H_INCLUDED
