//  Problema 28: redireccionando
//  Fecha: 10/4/2020; 8:36 am
//  Revisin: 11/9/2020; 12:22 pm
//  S. Galliano.

#include "entrada.h"
#include <iostream>
#include <cstdlib>
#include <iomanip>
#include <algorithm>

int main() {
    Estads est; // la clase que calcula
    // encabezado
    std::cout
    << "Ejercicio 28: algunos estad\241sticos.\n\n"
    << std::setw( 3 ) << "No."
    << std::setw( 8 ) << "Valor"
    << std::setw( 8 ) << "M\241n."
    << std::setw( 8 ) << "M\240x."
    << std::setw( 8 ) << "Rango"
    << std::setw( 8 ) << "Suma"
    << std::setw( 8 ) << "Moda"
    << std::setw( 8 ) << "Med."
    << std::setw( 8 ) << "Prom."
    << std::setw( 8 ) << "Desv." << '\n'
    << std::setw( 76 ) << std::setfill( '-' ) << '\n' << std::setfill( ' ' )
    << std::fixed << std::right;
    // valores
    int valor; // valor ledo

    while ( std::cin >> valor ) {
        est.vect.push_back( valor );
        sort( est.vect.begin(), est.vect.end() );

        //  saca la lnea i-sima
        std::cout << std::setprecision( 0 )
                  << std::setw( 3 ) << est.cuenta()
                  << std::setw( 8 ) << valor
                  << std::setw( 8 ) << est.mi_min()
                  << std::setw( 8 ) << est.mi_max()
                  << std::setw( 8 ) << est.rango()
                  << std::setw( 8 ) << est.suma();

        //  la moda se trata diferente
        HUGE_VAL == est.moda()
            ? std::cout << std::setw( 8 ) << "n/d"
            : std::cout << std::setw( 8 ) << est.moda();

        std::cout << std::setprecision( 2 )
                  << std::setw( 8 ) << est.mediana()
                  << std::setw( 8 ) << est.promedio();

        //  la desviacin se trata diferente
        1 == est.cuenta()
            ? std::cout << std::setw( 8 ) << "n/d\n"
            : std::cout << std::setw( 8 ) << est.desviacion() << '\n';
    } // while

    std::cout << std::setw( 77 ) << std::setfill( '-' ) << '\n';
    return EXIT_SUCCESS;
}
