#ifndef ENTRADA_H_INCLUDED
#define ENTRADA_H_INCLUDED

//  entrada.h: declaraciones para el programa 16
//  Fecha: 26/8/2019; 7:52 am
//  Revisin: 11/9/2020; 12:22 pm
//  Por S. Galliano.

#include <string>
typedef std::string Str;
const Str ERR( "\nNo pude abrir el archivo; abortando.\n" );

#include <vector>
typedef std::vector<double> Vct;

struct Estads {
    //  interfaz
    double suma      ();
    double mediana   ();
    double moda      ();
    double promedio  ();
    double varianza  ();
    double desviacion();
    double mi_max    ();
    double mi_min    ();
    double rango     ();
    int cuenta       ();
    void leerArchivo ( Str archy );
    //  miembro
    Vct vect;
};

#include <ostream>

//  flujo de salida especializado
//  input: el flujo la identidad y el valor
//  output: la salida en pantalla
void muestra( std::ostream & escribe, Str ID, double stat );

#endif // ENTRADA_H_INCLUDED
