//  estads.cpp: definiciones para el problema 29
//  Fecha: 30/5/2020; 11:30 am
//  Revisin: 13/9/2020; 5:02 pm
//  Por: S. Galliano.
#include "estads.h"
#include <algorithm>

double Stat::suma    () {
    return std::accumulate( vct.begin(), vct.end(), 0.0 );
}
double Stat::promedio() {
    return suma() / vct.size();
}

double Stat::mediana() {
    double med;
    int n = vct.size(); // tamao
    int idx = 0.5 * n;  // se busc el ndice del medio
    n % 2               // se calcul la mediana
        ? med = vct[idx]
        : med = 0.5 * ( vct[idx - 1] + vct[idx] );
    return med;
}

#include <cmath>

double Stat::desviac() {
    double total = 0;
    double n = vct.size();
    double ave = promedio();
    for ( auto x: vct ) total += pow( x - ave, 2 ); // se visitan los nodos
    return sqrt( total / ( n - 1 ) );               // desviacin tpica
}
