#ifndef ESTADS_H_INCLUDED
#define ESTADS_H_INCLUDED

//  estads.h: definiciones para el problema 29
//  Fecha: 30/5/2020; 11:30 am
//  Revisin: 13/9/2020; 5:02 pm
//  Por: S. Galliano.

const long POBLACN = 1000000; // tamao de la poblacin
const long MUESTRA = 2000;    // tamao de una muestra
const int  PASES   = 5;       // cantidad de pases

#include <vector>
typedef std::vector<double> Vct;

struct Stat {
    //  interfaz: estadsticos mnimos
    double suma    ();
    double mediana ();
    double promedio();
    double desviac ();
    //  miembro
    Vct vct; // un vector
};

#endif // ESTADS_H_INCLUDED
