//  Problema 23: estadsticas
//  Fecha: 29/5/2020; 8:27 pm
//  Revisin: 13/9/2020; 5:02 pm
//  S. Galliano.

#include "estads.h"
#include "muestra.h"
#include <iostream>
#include <cstdlib>
#include <iomanip>
#include <algorithm>
#include <tuple>

int main() {
    std::cout <<
    "Problema 29: muestreo estad\241stico.\n"
    "Promedio de " << PASES << " muestras de " << MUESTRA <<
    " valores\nc/u sobre " << POBLACN << " de valores.\n\n";

    Vals respuesta; // la respuesta
    double Media, Desv, Medn, Rang, Max, Min; // los valores

    //  la poblacin
    Stat * poblacion = new Stat;
    std::cout << "Paciencia. Preparando el archivo...";
    poblacion->vct = generaPoblacion();
    std::cout << "hecho.\nResp:\n";

    sort( poblacion->vct.begin(), poblacion->vct.end() );
    Media = poblacion->promedio();
    Desv  = poblacion->desviac();
    Medn  = poblacion->mediana();
    Max   = *max_element( poblacion->vct.begin(), poblacion->vct.end() );
    Min   = *min_element( poblacion->vct.begin(), poblacion->vct.end() );
    Rang  = Max - Min;
    respuesta = std::make_tuple( Media, Desv, Medn, Rang );
    imprimeVals( respuesta );

    //  las muestras
    double Med = 0, Des = 0, Mdn = 0, Rng = 0;
    std::cout << "Paciencia. Muestreando...";

    //  muestreo por pases
    for ( int i = 0; i < PASES; ++i ) {
        respuesta = generaMuestra();
        std::tie( Media, Desv, Medn, Rang ) = respuesta;
        Med += Media;
        Des += Desv;
        Mdn += Medn;
        Rng += Rang;
    } // for

    //  muestreo promedio
    Med /= PASES;
    Des /= PASES;
    Mdn /= PASES;
    Rng /= PASES;
    respuesta = std::make_tuple( Med, Des, Mdn, Rng );

    std::cout << "hecho.\nResp:\n";
    imprimeVals( respuesta );

    delete poblacion;
    system( "pause" );
    return EXIT_SUCCESS;
}
