#ifndef MUESTRA_H_INCLUDED
#define MUESTRA_H_INCLUDED

//  muestra.h: definiciones para el problema 29
//  Fecha: 1/6/2020; 2:20 pm
//  Revisin: 13/9/2020; 5:02 pm
//  Por: S. Galliano.

#include "estads.h"
#include <tuple>
typedef std::tuple<double, double, double, double> Vals;

//  genera los valores y los pone en el archivo
//  input: nada
//  output: el vector se pasa a la clase;
Vct generaPoblacion();

//  genera un punto de entrada al archivo de valores
//  input: nada
//  output: un punto de entrada al archivo
long generaEntrada();

//  genera una muestra
//  input: un puntero a la clase
//  output: los valores de la muestra
Vals generaMuestra();

//  imprime los estadsticos
//  input: un puntero a la clase
//  output: sus estadsticos a consola
void imprimeVals( Vals & valores );

#endif // MUESTRA_H_INCLUDED
