//  Problema 30a:
//  Fecha: 3/4/2020; 11:21 am
//  S. Galliano.

#include "../../Programas/deposito/print.h"
#include "../../Programas/deposito/rnd.h"
#include <iostream>
#include <istream>
#include <algorithm>
#include <vector>

// cantidad de nmeros aleatorios
const int NUMEROS = 10000000;

// cantidad de pruebas
const int PRUEBAS = 10;

// ancho del campo de salida
const int A = 3;

int main() {
    std::vector<int> Vct( NUMEROS );
    srand( time( 0 ) );               // una semilla nueva
    int Min = 0,    extremo_m = 5;    // mximos, mnimos...
    int Max = 9999, extremo_M = 9995; // ...y extremos
    double total_m = 0, total_M = 0;  // los acumulados totales
    int cuenta_m, cuenta_M;           // las cantidades de los valores
    int n;                            // un nmero seudoaleatorio

    std::cout
    << "Ejercicio 30: generaci\242n de valores azarosos con alta calidad.\n"
    "Los valores dados deben quedar cerca de " << NUMEROS / ( Max + 1 ) << "\n\n";
    clock_t inicio = clock();

    for ( int pase = 0; pase < PRUEBAS; ++pase ) {
        cuenta_m = cuenta_M = 0; // valor inicial para el pase

        RELLENA_I( Vct, Min, Max );
        n = std::count( Vct.begin(), Vct.end(), extremo_m );
        cuenta_m += n;
        n = std::count( Vct.begin(), Vct.end(), extremo_M );
        cuenta_M += n;

        total_m += cuenta_m; // acumulado de las cuentas para...
        total_M += cuenta_M; // ...tomar su promedio al finalizar

        // muestra las generaciones
        std::cout << "Pase #"    << std::setw( A ) << pase + 1 << " "
                  << extremo_m << ": " << std::setw( A ) << cuenta_m << "\t"
                  << extremo_M << ": " << std::setw( A ) << cuenta_M << '\n';
    } // for pase

    clock_t fin = clock();

    double diferencia = difftime( fin, inicio ) / CLOCKS_PER_SEC;
    std::cout << "-----------------------------\n"
              << "Promedio para " << PRUEBAS << std::setw( A )
              << " pases: 5: "    << total_m / PRUEBAS
              << "; 9995: "       << total_M / PRUEBAS
              << std::setw( A - 1 )
              << "\nTard\202 " << diferencia << " s\n\n";
    system( "pause" );
    return EXIT_SUCCESS;
}
