// Programa a1: uso del for_each
// Fecha: 3/9/2019; 8:40 pm
// Revisin: 8/9/2020; 9:31 am
// S. Galliano.

#include <array>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cmath>

const int N = 10;
using namespace std;

// funcin para imprimir una lnea de valores
void mostrar(int x) {
    cout << setprecision(0) <<
    setw(3) << x            <<
    setw(8) << pow(x, 2)    <<
    setw(8) << pow(x, 3)    <<
    setprecision(4)         <<
    setw(10) << 1.0 / x     <<
    setw(10) << sqrt(x)     << '\n';
}

int main() {
    cout << "Programa auxiliar 1: uso del for_each()\n\nTabla de n\243meros.\n" <<
    //  encabezado
    setw(40) << setfill('-') << '\n' << setfill(' ') << fixed <<
    setw(3)  << "No"         <<
    setw(8)  << "Cuad"       <<
    setw(8)  << "Cubo"       <<
    setw(10) << "Inverso"    <<
    setw(10) << "Ra\241z"    << left <<
    setw(40) << setfill('-') << '\n' << setfill(' ') << right << '\n';

    array<int, N>ary;
    iota(ary.begin(), ary.end(), 1); // llenado

    for_each(ary.begin(), ary.end(), mostrar);
    cout << setw(40) << setfill('-') << '\n';
    system("pause");
    return EXIT_SUCCESS;
}
