// Programa a3: uso del for basado en rangos
// Fecha: 3/9/2019; 9:12 pm
// Revisin: 8/9/2020; 9:55 am
// S. Galliano.

#include <list>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cmath>

const int N = 10;
using namespace std;

int main() {
    cout << "Programa auxiliar 3: el for basado en rangos.\n\nTabla de n\243meros.\n" <<

    //  encabezado
    setw(40) << setfill('-') << '\n' << setfill(' ') << fixed <<
    setw(3)  << "No"         <<
    setw(8)  << "Cuad"       <<
    setw(8)  << "Cubo"       <<
    setw(10) << "Inverso"    <<
    setw(10) << "Ra\241z"    << left <<
    setw(40) << setfill('-') << '\n' << setfill(' ') << right << '\n';

    // una lista STL
    std::list<int> ary(N);         // 10 elementos iniciales
    iota(begin(ary), end(ary), 1); // llenado completo de la lista

    // ciclo para imprimir los valores lnea a lnea
    for ( auto x: ary ) {
        cout << setprecision(0) <<
        setw(3) << x            <<
        setw(8) << pow(x, 2)    <<
        setw(8) << pow(x, 3)    <<
        setprecision(4)         <<
        setw(10) << 1.0 / x     <<
        setw(10) << sqrt(x)     << '\n';
    } // for

    cout << setw(40) << setfill('-') << '\n';
    system("pause");
    return EXIT_SUCCESS;
}
