//  Programa auxiliar 5: binders.cpp
//  Fecha: 30/10/2020
//  S. Galliano

#include <iostream>
#include <cstdlib>
#include <vector>
#include <numeric>
#include <algorithm>
#include <iterator>

int main() {
    using namespace std;
    cout << "Ejercicio auxiliar 4: ejemplos con binder1st & binder2nd.";
    typedef vector<int>::iterator iter;
    cout << "\n\nCrea un vector :\n  ";
    vector<int> vct( 4 );
    std::iota( vct.begin(), vct.end(), 1);
    copy( vct.begin(), vct.end(), ostream_iterator<int>( cout, " " ));

    int tres = 3;
    cout << "\n\nAhora crea un predicado unario 'igual_a_tres'\n"
            "uniendo el valor tres al functor binario equal_to\n"
            "y lo usa llamando a find_if.";
    binder1st<equal_to<int>> igual_a_tres = bind1st( equal_to<int>(), tres );
    iter it1 = find_if( vct.begin(), vct.end(), igual_a_tres );
    cout << "\n  " << *it1;

    cout << "\n\nY ahora hace lo mismo, pero usando bind2nd,\n"
            "al vuelo. El resultado es el mismo porque\n"
            "el operador == es conmutativo.\n  ";
    iter it2 = find_if( vct.begin(), vct.end(), bind2nd( equal_to<int>(), tres ) );
    cout << *it2 << "\n\n";
    system( "pause" );
    return EXIT_SUCCESS;
}
