//  auxi.cpp: definiciones para el programa auxiliar a3
//  Fecha: 13/11/2019; 3:23 pm

#include "auxi.h"
#include <iostream>
#include <iomanip>

// convierte un slice en un valarray
std::valarray<double> VA ( const std::valarray<double> & valarray_slice ) {
    return std::valarray<double>( valarray_slice );
}

// imprime un valarray (o slice) en una columna
void printValarray ( const std::valarray<double> & va ) {
    for ( unsigned i = 0; i < va.size(); i++ ) {
        std::cout << std::setw(4) << va[i] << '\n';
    } // for
    std::cout << std::setw(0) << '\n';
}

// imprime un valarray ( o sus slices) en columnas
void printValarray ( const std::valarray<double> & va, int cols ) {
    for ( unsigned i = 0; i < va.size() / cols; ++i ) {
        for ( int j = 0; j < cols; ++j ) {
            std::cout << std::setw(8) << va[i * cols + j];
        } // for j
        std::cout << '\n';
    } // for i
    std::cout << std::setw(0) << '\n';
}
