#ifndef AUXI_H_INCLUDED
#define AUXI_H_INCLUDED

//  auxi.h: definiciones para el programa auxiliar a3
//  Fecha: 13/11/2019; 3:23 pm

#include <valarray>

// convierte un slice en un valarray
// input: el subconjunto o slice
// output: un valarray
std::valarray<double> VA ( const std::valarray<double> & valarray_subset );

// imprime un valarray (o slice) en una columna
// input: el valarray
// output: valores a consola en una columna
void printValarray ( const std::valarray<double> & va );

// imprime un valarray ( o sus slices) en columnas
// input: el valarray y la cantidad de columnas
// output: valores a consola en una tabla
void printValarray ( const std::valarray<double> & va, int cols );

#endif // AUXI_H_INCLUDED
