//  programa auxiliar 5: valarray
//  Fecha: 27/11/2019; 2:45 pm
//  Revisin: 29/11/2019; 12:52 pm
//  S. Galliano

#include "../deposito/varray.h"
#include "../deposito/rnd.h"
#include "../deposito/print.h"

using namespace std;
const int FILAS = 3; // filas y columnas; podran pedirse...
const int COLS  = 4; // ...directamente al usuario

int main() {
    cout << "Programa auxiliar 5: valarray\n\nTrabajando con " << FILAS
         << " filas, " << COLS << " columnas y 2 decimales.\n\n";

    valarray<double>va(FILAS*COLS);     // valarray con 12 nmeros
    RELLENA_VD(va, FILAS*COLS, 1, 100); // lleno de valores al azar

    cout << std::setprecision(2) << std::fixed << "La tabla:\n";
    PRINTVA(va, COLS);
    cout << "\nEl valor m\240ximo es "   << va.max()
         << "\nEl valor m\241nimo es "   << va.min()
         << "\nEl alcance o rango es "   << va.max() - va.min()
         << "\nLa sumatoria es "         << va.sum()
         << "\nEl valor promedio es de " << va.sum() / va.size() << "\n\n";

    cout << "Extrayendo la ra\241z cuadrada a la tabla:\n";
    va = sqrt(va); PRINTVA(va, COLS);
    cout << "\nLlevando sus valores a la mitad:\n";
    va /= 2; PRINTVA(va, COLS);
    cout << "\nHaciendo la columna 1 = columna 2 x columna 3:\n";
    va[slice(0, 3, 4)] = VA(va[slice(1, 3, 4)]) * VA(va[slice(2, 3, 4)]);
    PRINTVA(va, COLS);
    cout << "\nPoniendo el promedio de las otras en la columna 4:\n";
    va[slice(3, 3, 4)] = (
        VA(va[slice(0, 3, 4)]) +
        VA(va[slice(1, 3, 4)]) +
        VA(va[slice(2, 3, 4)])   ) / static_cast<double>(FILAS);
    PRINTVA(va, COLS);
    cout << '\n';

    system("pause");
    return EXIT_SUCCESS;
}
