/*
    Programa 3-Lmites enteros

    Descripcin:recodificacin del programa 5, tomo 1, valores
    lmites de enteros y caracteres en este sistema.

    Fecha: 21/8/2019; 4:57 pm
    S. Galliano.
*/

#include <iostream>
#include <cstdlib>
#include <limits>

typedef std::numeric_limits<char>              lChar;
typedef std::numeric_limits<short>             lShort;
typedef std::numeric_limits<unsigned short>    lUshort;
typedef std::numeric_limits<int>               lInt;
typedef std::numeric_limits<unsigned int>      lUint;
typedef std::numeric_limits<long int>          lLintl;
typedef std::numeric_limits<unsigned long int> lUlint;

using std::numeric_limits;
using std::cout;

int main() {
    cout <<
    "Programa 2: caracter\241sticas de este sistema (1)\n\n"
    "Caracteres:\n"
    " bits por byte = " << lChar::digits << '\n';
    lChar::is_signed
        ?cout << " El char presenta signo.\n"
        :cout << " El char no presenta signo.\n";
    lChar::is_specialized
        ?cout << " La cadena C++ no tiene l\241mites.\n"
        :cout << " La cadena C++ tiene l\241mites.\n";
    lChar::is_iec559
        ?cout << " Cumple con las normas IEC 559\n\n"
        :cout << " No cumple con las normas IEC 559\n\n";
    cout <<
    "N\243meros:\n short:"
    "\n  valor m\241nimo = " << lShort::min() <<
    "\n  valor m\240ximo = " << lShort::max() << '\n' <<

    "\n unsigned short:"
    "\n  valor m\241nimo = " << lUshort::min() <<
    "\n  valor m\240ximo = " << lUshort::max() << '\n' <<

    "\n int:"
    "\n  valor m\241nimo = " << lInt::min() <<
    "\n  valor m\240ximo = " << lInt::max() << '\n' <<

    "\n unsigned int:"
    "\n  valor m\241nimo = " << lUint::min() <<
    "\n  valor m\240ximo = " << lUint::max() << '\n' <<

    "\n long int:"
    "\n  valor m\241nimo = " << lLintl::min() <<
    "\n  valor m\240ximo = " << lLintl::max() << '\n' <<

    "\n unsigned long int:"
    "\n  valor m\241nimo = " << lUlint::min() <<
    "\n  valor m\240ximo = " << lUlint::max() << "\n\n";

    system("pause");
    return EXIT_SUCCESS;
}
