// Programa 7: listas
// Fecha: 13/4/2020; 7:27 pm
// Revisin: 8/9/2020; 1 pm
// S. Galliano.

#include "../deposito/print.h"
#include "menu.h"
#include "lse.h"
#include <iostream>
#include <cstdlib>

int main() {
    Str info( "Problema 7: manejo de una LSE.\n\n" );
    Nodo * head = new Nodo;
    short opcion;
    int valor, pos, n; // valor, posicin y tamao

    while( true ) {
        opcion = menu( info );

        if( Terminar == opcion ) {
            head->nodo.clear();
            delete head;
            return EXIT_SUCCESS;
        } else
            n = head->nodo.size();

        switch( opcion ) {
        case Insertar:
            std::cout << "\250Valor? ";
            ( std::cin >> valor ).get();

            if( head->enLista( valor ) )
                std::cerr << ERR_Y;
            else {
                std::cout << "(0 a la cabeza) \250Posici\242n? ";
                ( std::cin >> pos ).get();
                head->adiciona( valor, pos );
                std::cerr << HECHO;
            } // if-else
            break;
        case Enumerar:
            0 == n
                ? std::cerr << ERR_V
                : 1 == n
                    ? std::cout << "Un nodo.\n\n"
                    : std::cout << n << " nodos.\n\n";
            break;
        case Buscar:
            if( 0 == n )
                std::cerr << ERR_V;
            else {
                std::cout << "\250Valor? ";
                ( std::cin >> valor ).get();
                head->enLista( valor )
                    ? std::cout << ERR_Y
                    : std::cout << ERR_N;
            } // if-else
            break;
        case Imprimir:
            if( 0 == n )
                std::cerr << ERR_V;
            else {
                LISTA( head->nodo, "Lista: " );
                std::cout << "\n\n";
            } // if-else
            break;
        case Eliminar:
            if( 0 == n )
                std::cout << ERR_V;
            else {
                std::cout << "\250Valor? ";
                ( std::cin >> valor ).get();

                if( head->enLista( valor ) ) {
                    head->nodo.remove( valor );
                    std::cout << HECHO;
                } else
                    std::cerr << ERR_N;
            } // if-else
            break;
        case Vaciar:
            if( 0 == n )
                std::cout << ERR_V;
            else {
                char procedo;
                std::cout << "Esta operaci\242n destruir\240 la lista.\n\250Procedo? (s/n) ";
                std::cin >> procedo;

                if( 'S' == toupper( procedo ) ) {
                    head->nodo.clear();
                    std::cout << HECHO;
                } else std::cerr << "Operaci\242n abortada.\n\n";
            } // if-else
            break;
        } // switch
        system( "pause" );
    } // while
}
