// Programa 7: mapas
// Fecha: 26/11/2019; 6:42 am
// Revisin: 8/9/2020; 5:10 pm
// S. Galliano.


#include "monedas.h"
#include "menu.h"
#include <iostream>
#include <cstdlib>

const Str ARCHY( "c:/temp/BD/monedas.txt" );

int main() {
    Str info( "Programa 8: pa\241ses que usan divisas\ncomo moneda nacional.\n\n" );
    Moneda paises;
    Str nombre, iso;
    int opcion;

    try {
        paises = cargar( ARCHY );
    } catch( Str ) {
        std::cout << ERR;
        return EXIT_FAILURE;
    } // try-catch

    while( true ) {
        opcion = menu( info );

        if( FIN == opcion ) return EXIT_SUCCESS;

        switch( opcion ) {
        case EUR:
            nombre = "Euro";
            iso = "EUR";
            break;
        case USD:
            nombre = "D\242lar americano";
            iso = "USD";
            break;
        case CAD:
            nombre = "D\242lar canadiense";
            iso = "CAD";
            break;
        case JPY:
            nombre = "Yen japon\202s";
            iso = "JPY";
            break;
        case CNY:
            nombre = "Yuan chino";
            iso = "CNY";
            break;
        case GBP:
            nombre = "Libra esterlina";
            iso = "GBP";
            break;
        case CHF:
            nombre = "Franco suizo";
            iso = "CHF";
            break;
        case RUB:
            nombre = "Rublo ruso";
            iso = "RUB";
            break;
        case AUD:
            nombre = "D\242lar Australiano";
            iso = "AUD";
            break;
        } // switch

        mostrar( iso, nombre, paises );
        system( "pause" );
    } // while
}
