// monedas.cpp: definiciones para el programa 7
// Fecha: 26/11/2019; 6:42 am
// Revisin: 8/9/2020; 5:10 pm
// S. Galliano
#include "monedas.h"
#include <fstream>

//  carga la BD
Moneda cargar( Str archy ) {
    std::ifstream Leyendo( archy );
    if ( not Leyendo.is_open() ) throw ERR; // abortar si fall

    Moneda temp;     // un multimapa temporal
    Str iso, nombre; // las variables

    while ( Leyendo.good() ) {
        std::getline( Leyendo, iso, ',' );        // una lectura
        std::getline( Leyendo, nombre, '\n' );    // la siguiente
        temp.insert( std::make_pair( iso, nombre ) ); // inserta el par
    } // while

    return temp;
}

#include <iostream>
using std::cout;

//  muestra los pases por moneda
void mostrar( Str iso, Str nombre, const Moneda & moneda ) {
    int n = moneda.count( iso );
    cout << '\n';

    if ( "GBP" == iso )
        cout << n << " pa\241ses usan la libra esterlina:\n\n";
    else
        1 == n
            ? cout << "Un pa\241s usa el " << nombre << ":\n\n"
            : cout << n << " pa\241ses usan el " << nombre << ":\n\n";

    for ( auto x : moneda )
        if( x.first == iso ) cout << "  " << x.second << '\n';

    cout << '\n';
}
