#ifndef CARTAS_H_INCLUDED
#define CARTAS_H_INCLUDED

//  cartas.h: declaraciones para el problema 12
//  Fecha: 25/8/2019; 7:10 am
//  Revisin: 29/3/2020; 6 pm
//  Por S. Galliano.

const int MAZO  = 40; // un mazo trae 40 cartas
const int PALOS =  4; // son 4 palos en la baraja
const int CAMPO = 18; // ancho del campo de salida

#include <string>
typedef std::string Str;

#include <array>
typedef std::array<Str, MAZO> Mazo; // la baraja

//  crea un mazo de cartas y lo baraja
//  input: el array de las cartas
//  output: el mazo est barajado
void cargar( Mazo & cartas );

//  reparte la baraja entre 4 jugadores
//  input: el array de cartas y el de posicin
//  output: el mazo est repartido
void repartir( Mazo & cartas );

#endif // CARTAS_H_INCLUDED
