#ifndef ENTRADA_H_INCLUDED
#define ENTRADA_H_INCLUDED

//  entrada.h: declaraciones para el programa 16
//  Fecha: 26/8/2019; 7:52 am
//  Revisin: 11/9/2020; 12:22 pm
//  Por S. Galliano.

#include <algorithm>
#include <ostream>
#include <string>
typedef std::string Str;
const Str ERROR( "\nNo pude abrir el archivo; abortando.\n" );
typedef std::vector<double> Vct;

struct Estads {
    //  interfaz
    double suma     ();
    double mediana  ();
    double moda     ();
    double promedio ();
    double varianza ();
    double miMax    ();
    double miMin    ();
    double cuenta   ();
    void leerArchivo( Str archy );
    // miembro
    Vct vec;
};

//  flujo de salida especializado
void muestra( std::ostream & escribe, Str ID, double stat );

#endif // ENTRADA_H_INCLUDED
