#ifndef CONVERSOR_H_INCLUDED
#define CONVERSOR_H_INCLUDED
// conversor.h: declaraciones para el programa 17

#include <string>
typedef std::string Str;
const Str ERR_E( "No pude escribir. Abortando.\n" );
const Str ERR_L( "No pude leer. Abortando.\n" );

#include <fstream>
#include <vector>
typedef std::vector<Str> Vct;
typedef std::pair<int, float> Par;

// la clase toma un valor en mg/dL y lo entrega como mmol/L
// escribe la informacin a disco y a consola
struct Lector {
    Lector(); // constructor
    // mtodos
    Par  tomarLectura();
    void leerData( std::istream & leer );
    void mostrarInfo( std::ostream & escribir, Par dat );
    // miembros
    Str archy; // archivo de datos
    Str fecha; // fecha y hora actuales
    Vct vct;   // vector que carga del archivo
};

#endif // CONVERSOR_H_INCLUDED
