// Programa 17: conversin de unidades
// Fecha: 26/8/2019; 9 am
// Revisin: 11/9/2020; 6:44 pm
// S. Galliano.

#include "conversor.h"
#include <iostream>
#include <cstdlib>
#include <ios>

int main() {
    Lector * pLect = new Lector;
    Par dat;

    try {
        dat = pLect->tomarLectura();
    } catch ( Str ) {
        std::cerr << ERR_L;
        return EXIT_FAILURE;
    } // try-catch

    try {
        std::ofstream aDisco( pLect->archy, std::ios::app );
        pLect->mostrarInfo( std::cout, dat );
        pLect->mostrarInfo( aDisco, dat );
    } catch ( Str ) {
        std::cerr << ERR_E;
        return EXIT_FAILURE;
    }; // try-catch

    std::ifstream deDisco( pLect->archy );
    pLect->leerData( deDisco );
    delete pLect;
    system( "pause" );
    return EXIT_SUCCESS;
}
