//  Programa 19: listado de pares
//  Fecha: 13/6/2020; 2:39 pm
//  Revisin: 12/9/2020; 9:50 am
//  Por: S. Galliano.

#include "../deposito/rnd.h"
#include "auxiliar.h"
#include <iostream>
#include <cstdlib>
#include <ctime>

const int N = 5;     // cantidad de elementos por lista
const int menor = 1; // lmites de los valores
const int Mayor = N * 3;

int main() {
    std::cout << "Programa 19: un arreglo de listas num\202ricas.\n\n";
    srand( time( 0 ) );

    //  crear el arreglo
    Vct ary;           // un vector STL
    char ID[L_tmpnam]; // nombres temporales automticos

    //  poblar el arreglo de listas
    for ( int i = 0; i < N; ++i ) {
        tmpnam( ID );                  // un nombre temporal
        Lst ID( N );                   // una lista STL
        RELLENA_I( ID, menor, Mayor ); // la rellena
        ary.push_back( ID );           // la inserta en el vector
    } // for

    //  imprimir el arreglo
    std::cout << "El arreglo de " << N << " listas (+-->):\n";
    for_each( ary.begin(), ary.end(), imprimirOriginal );
    std::cout << '\n';

    //  imprimir el arreglo ordenado a->z
    std::cout << "El arreglo ordenado (z-a +-->):\n";
    sort( ary.begin(), ary.end(), std::greater<Lst>() );
    for_each( ary.begin(), ary.end(), imprimirOriginal );
    std::cout << '\n';

    //  imprimir las listas ordenadas
    std::cout << "Sus listas ordenadas (z-a +-->):\n";
    for_each( ary.begin(), ary.end(), imprimirOrdenada );
    std::cout << '\n';

    system( "pause" );
    return EXIT_SUCCESS;
}
