// Problema 1: uso plantillas y del algoritmo STL swap
// Fecha: 5/9/2019:4:52 pm
// Revisin 12/9/2020; 5:24 pm
// S. Galliano.

#include <iostream>
#include <cstdlib>

///@brief Intercambia dos variables del mismo tipo.
///@param <b>str</b> es el prompt.
///@param <b>x, </b> son las dos variables.
///@return las variables se intercambiaron.
template <typename T>
void INTERCAMBIAR(T &x, T &y) {
    std::cout << "x = ";
    (std::cin >> x).get();
    std::cout << "y = ";
    (std::cin >> y).get();
    std::swap(x, y);
}

const int ANCHO = 6; // ancho
#include <iomanip>

int main() {
    using std::cout;
    using std::setw;
    cout << "Ejercicio 1: intercambio de valores.\n\n";
    int e1, e2;
    cout << "Dos enteros:\n";
    INTERCAMBIAR(e1, e2);
    cout << "Despu\202s:\n" << "x = " << e1 << setw(ANCHO) << "y = " << e2 << "\n\n";

    float f1, f2;
    cout << "Dos valores reales:\n";
    INTERCAMBIAR(f1, f2);
    cout << "Despu\202s:\n" << "x = " << f1 << setw(ANCHO) << "y = " << f2 << "\n\n";

    std::string s1, s2;
    cout << "Dos palabras:\n";
    INTERCAMBIAR(s1, s2);
    cout << "Despu\202s:\n" << "x = " << s1 << setw(ANCHO) << "y = " << s2 << "\n\n";

    system("pause");
    return EXIT_SUCCESS;
}
