//  secante.cpp: definiciones para el problema 2
//  Fecha: 21/1/2020; 10:06 am
//  Por: S. Galliano.
#include "secante.h"
#include <cmath>

// funcin auxiliar: comprueba ambos lmites
// true si el valor cae dentro
bool enLimite( double grads ) {
    if ( std::abs( grads - 90 ) < EPS ) return true;
    else return false;
}

// calcula la secante de un ngulo
// si est en los lmites, se devuelve el error
double secante( double grads ) {
    double rads = grads * K;
    if ( enLimite( grads ) ) throw INFINITO;
    else return 1.0 / cos( rads );
}
