//  diferencia.cpp: definiciones para el problema 5
//  Fecha: 5/9/2019; 11:21 am
//  Revisin: 17/12/2019; 9:22 am
//  Por S. Galliano.

#include "diferencia.h"
#include <iostream>
using std::cout;
using std::cin;
using std::getline;

void Hora::tomar() {
    cout << "Entrar la hora de Cuba, luego los minutos\n"
            "y por \243ltimo el meridiano:\n\nHora: ";
    (cin >> hora).get();
    cout << "Minutos: ";
    (cin >> mins).get();
    cout << "\250(A)m o (P)m? ";
    getline(cin, amPM);
}

void Hora::normalizar() {
    // normalizar la hora de Cuba a la de Mosc
    if ( toupper(amPM[0]) == 'P' ) hora += 12; // hora vespertinas
    mins += 30; // diferencia de minutos

    if ( mins >= 60 ) { // se pas de minutos?
        mins -= 60;     // ajstarlos y...
        ++hora;           // ...ajustar la hora
    } // if

    hora += 8; // diferencia de hora con Mosc

    if ( hora >= 24) {
        hora -= 12;                // bajar las hora
        if ( hora > 12 ) hora -= 12; // bajarlas ms si hace falta
        amPM = " am del otro d\241a.\n";
    } else if ( hora > 12 ) {
        hora -= 12;                // bajar las hora
        amPM = " pm del mismo d\241a.\n";
    } else {
        amPM = " am del mismo d\241a.\n";
    } // if-else
}

void Hora::responder() const {
    cout << "\nHora de Mosc\243: " << hora << ":" << mins << amPM << '\n';
}
