//  check.cpp: definiciones para el programa
//  Fecha: 1/12/2019; 10:35 am
//  S. Galliano.
#include "check.h"
#include <iostream>
using std::cout;
#include <iomanip>
using std::setw;

//  calcula el check sum del dato
int chksum( Str dato ) {
    const int N = 256;
    int chk, total = 0;
    cout << '\n' << setw( 6 ) << " " << "C\242d." << setw( 6 ) << "Suma\n";

    for ( auto x : dato ) {
        chk = static_cast<int>( x );
        total += chk;
        cout << x << ": " << setw( 6 ) << chk << setw( 6 ) << total << '\n';
    } // for

    chk = total % N;
    cout << "\nChecksum (" << total << " % " << N << ") = " << chk << '\n';
    return chk;
}

using std::ios;

//  muestra el checksun en varios formatos
void mostrar( Str dato, int chk ) {
    cout.setf( ios::showbase | ios::uppercase );
    cout << "\n" << std::hex <<
         "El Checksum de \"" << dato << "\" es = " << chk << "\n"
         "que en octal es "  << std::oct << chk <<
         " y en decimal, "   << std::dec << chk << "\n\n";

}
