#ifndef DATOS_H_INCLUDED
#define DATOS_H_INCLUDED

//  datos.h: definiciones de la estructura de datos para el problema 8
//  Fecha: 23/1/2020; 1:24 pm
//  Revisin: 12/9/2020; 6:36 pm
//  Por: S. Galliano.

#include <string>
typedef std::string Str;
const Str ERR( "\nError: la palabra no es una preposici\242n.\n\n" );

#include <map>
typedef std::multimap<Str, Str> Dicc;

//  carga la base de datos: 18 preposiciones
void cargar( Dicc & d );

//  muestra todas las preposiciones
void mostrarTodas( const Dicc & d );

//  muestra una preposicin
void mostrarUna( Str clave, const Dicc & d );

#endif // DATOS_H_INCLUDED
