// Problema 18: queue
// Fecha: 27/8/2019; 8:56 am
// Revisin: 13/9/2020; 5:55pm
// S. Galliano.

#include "menu.h"
#include <iostream>
#include <cstdlib>
#include <queue>

const std::string ERROR( "\nError: cola vac\241a.\n\n" );

int main() {
    std::queue<int> cola;
    Str info( "Ejercicio 18: manejo de una cola de enteros.\n\n" );
    int n, valor;
    short opcion;

    while ( true ) {
        opcion = menu( info );

        if ( terminar == opcion ) {
            return EXIT_SUCCESS;
        } else {
            n = cola.size();
        } // if-else

        switch ( opcion ) {
        case encolar:
            std::cout << "\nEntre un entero: ";
            ( std::cin >> valor ).get();
            cola.push( valor );
            std::cout << valor << " fue encolado.\n\n";
            break;
        case contar:
            if ( cola.empty() ) {
                std::cout << ERROR;
            } else {
                1 == n
                    ? std::cout << "\nUn nodo.\n\n"
                    : std::cout << '\n' << n << " nodos.\n\n";
            } // if-else
            break;
        case desencolar:
            if ( cola.empty() ) {
                std::cout << ERROR;
            } else {
                std::cout << '\n' << cola.front() << " fue desencolado.\n\n";
                cola.pop();
            } // if-else
            break;
        case puntas:
            if ( cola.empty() ) {
                std::cout << ERROR;
            } else {
                std::cout << "\nCabeza = " << cola.front()
                          << "; Cola = " << cola.back() << "\n\n";
            } // if-else
            break;
        } // switch
        system( "pause" );
    } // while
}
