// Programa 22
// Fecha: 9/5/2020; 12 m
// Revisin: 13/9/2020; 5:50 am
// S. Galliano.

#include "conversor.h"
#include "menu.h"
#include <iostream>
#include <cstdlib>

int main() {
    //  cargar la BD
    Cargador *carga = new Cargador;
    std::ifstream deDisco( carga->id );

    if ( not carga->leerData( deDisco, carga->vct ) ) {
        std::cerr << "No se pudo abrir la base de datos.\n\n";
        return EXIT_FAILURE;
    } // if

    //  solicitar un valor desde un men
    Str info( "Ejercicio 22: calculadora de conversiones.\n\n   MEN\351\n" );
    Dato dat;
    Info inf;
    double val;
    short opcion;

    while ( true ) {
        opcion = menu( info );

        if ( Fin == opcion ) {
            delete carga;
            return EXIT_SUCCESS;
        } // if

        std::cout << "\n\250Valor? ";
        ( std::cin >> val ).get();

        carga->dat = carga->vct[opcion - 1];
        carga->convertir( val );
        carga->imprimir();
        system( "pause" );
    } // while
}
