#ifndef GRAFICA_H_INCLUDED
#define GRAFICA_H_INCLUDED

//  grafica.h: definiciones para el programa 23
//  Fecha: 3/2/2020; 7 pm
//  Revisin: 13/9/2020; 6:12 am
//  Por: S. Galliano.

#include <map>
#include <string>
//  un multimapa que ordena de mayor a manor con un tercer parmetro
typedef std::multimap<float, std::string, std::greater<float>> Nodo;

Nodo * cargar();
void tabular( Nodo * nodo );
void graficar( Nodo * nodo );

#endif // GRAFICA_H_INCLUDED
