#ifndef ALMACEN_H_INCLUDED
#define ALMACEN_H_INCLUDED

//  almacen.h: definiciones para el problema 25
//  Fecha: 7/4/2020; 11 pm
//  Revisin: 15/10/2020; 7 pm
//  Por: S. Galliano.

#include "dulce.h"
#include <vector>
typedef std::vector<Trio> Stock;

const Str VACIA( "La BD est\240 vac\241a.\n\n" );
const Str MA_NO( "La marca no est\240.\n\n" );
const Str HECHO( "\n\255Hecho!\n\n" );

struct Almacen {
    Almacen();
    void mostrarStock();
    void adicionar( Str mk, int ct, double pr );
    void editarCt ( Str mk, int ct );
    void editarPr ( Str mk, double pr );
    void eliminarSnack( Str k );
    void contarStock();
    bool marcaEnStock( Str k );
    //  miembro
    Str mk;
    int ct;
    double pr;
    Stock stock;
};

#endif // ALMACEN_H_INCLUDED
