//  dulce.cpp: definiciones para el problema 25
//  Fecha: 7/4/2020; 11 pm
//  Revisin: 15/10/2020; 7 pm
//  Por: S. Galliano.
#include "dulce.h"

Dulce::Dulce( Str mk, double pr, int ct ) {
    dulce = std::make_tuple( mk, pr, ct );
}

#include <iostream>
using std::cout;
using std::cin;

void Dulce::entrarDato() {
    Str mk;
    cout << "   \250Marca? ";
    std::getline( cin, mk );
    double pr;
    cout << "  \250Precio? ";
	cin >> pr;
	int ct;
	cout << "\250Cantidad? ";
    cin >> ct;
    dulce = std::make_tuple( mk, pr, ct );
}

#include <iomanip>
using std::setw;

void Dulce::mostrarDato() {
	Str mk;
	double pr;
	int ct;
    tie( mk, pr, ct ) = dulce;
    cout.setf( std::ios_base::fixed );
    cout << std::setprecision ( 2 ) << std::left
         << setw( 13 ) << mk << std::right
         << setw( 8 ) << pr
         << setw( 8 ) << ct
         << setw( 8 ) << ct * pr << '\n';
    cout.unsetf( std::ios_base::fixed );
}
