#ifndef MENU_H_INCLUDED
#define MENU_H_INCLUDED

//  menu.h: definiciones para el problema 25
//  Fecha: 7/4/2020; 11 pm
//  Por: S. Galliano.
//  Revisin: 13/9/2020; 6:40 am

//  lo que pide el men
enum { Terminar, Mostrar, Adicionar, Borrar, EditarP, EditarC, Vaciar, Ayudar };

#include <string>

//  un men en consola
//  entrada: informacin al usuario
//  salida: men a consola
unsigned menu( std::string info );

//  la ayuda del men en consola
//  entrada: informacin al usuario
//  salida: la ayuda a consola
void ayuda( std::string info );

#endif // MENU_H_INCLUDED
