//  menu.cpp: definiciones para el problema 26
//  Fecha: 2/12/2019; 9:20 am
//  Revisin: 11/10/2020; 9:50 am
//  S. Galliano
#include "menu.h"
#include <iostream>
#include <cstdlib>
#include <cctype>

//  un men en consola
int menu( Str info ) {
    //  variables
    Str opcion;
    Str conjunto = "0123456789";
    Str::size_type idx;

    while ( true ) {
        system( "cls" );
        std::cout << info <<
        " BIBLIOTECA\n" <<
        " 1) Insertar una o varias obras.\n"
        " 2) Mostrar la biblioteca.\n"
        " 3) Contar las obras.\n"
        " 4) Buscar un autor.\n"
        " 5) Buscar una obra.\n"
        " 6) Eliminar una obra.\n"
        " 7) Eliminar un autor.\n"
        " 8) Vaciar la biblioteca.\n"
        " 9) Ayuda.\n"
        " 0) Terminar.\n"
        "Entre una opci\242n: ";
        std::getline( std::cin, opcion );
        idx = conjunto.find( opcion );

        if ( Str::npos == idx ) {
            std::cerr << "\nError: opci\242n ilegal.\n\n";
            system( "pause" );
        } else {
            return idx;
        } // if-en-cascada
    } // while
}

// la ayuda
void ayudar( Str info ) {
    system( "cls" );
    std::cout << info <<
    "AYUDA\n" <<
    "1) Inserta obras.\n"
    "   Acepta la entrada de varias obras.\n"
    "   Acepta varias obras de un mismo autor.\n"
    "2) Muestra la biblioteca.\n"
    "3) Cuenta la cantidad de obras en la biblioteca.\n"
    "4) Comprueba si un autor est\240 en la biblioteca.\n"
    "5) Comprueba si una obra est\240 en la biblioteca.\n"
    "6) Elimina una obra.\n"
    "7) Elimina un autor.\n"
    "8) Vac\241a la biblioteca.\n"
    "   Si la biblioteca no est\240 vac\241a, se advierte\n"
    "   al usuario. Cuidado. Esta operaci\242n no puede\n"
    "   ser deshecha.\n\n";
}
