//  ppunto.cpp: definiciones para el problema 27
//  Fecha: 21/8/2019; 8:25 pm
//  Revisin: 4/4/2020; 11:32 am
//  Por S. Galliano.

#include "ppunto.h"

double Vector::pPunto( Vector B ) {
    return ( duo.first * B.duo.first + duo.second * B.duo.second );
}

#include <cmath>

//  la norma del vector; los clculos son sobre uno temporal;
//  la elevacin al cuadrado se hace multiplicando el valor por si mismo
double Vector::norma() {
    double SDC = ( duo.first * duo.first + duo.second * duo.second );
    return sqrt( SDC );
}

#include <iostream>
using std::cout;
using std::cin;

void Vector::entrar( Str id ) {
    cout << "Vector " << id << " en formato (x, y): ";
    double a, b;
    char parentesis, coma;
    cin.setf( std::ios::skipws );

    cin >> parentesis;
    cin >> a;
    cin >> coma;
    cin >> b;

    cin.ignore( 255, '\n' );
    cin.unsetf( std::ios::skipws );

    duo = std::make_pair( a, b );
}

void Vector::mostrar( Str id ) {
    cout << "Vector " + id + " (" << duo.first << ", " << duo.second << ")\n";
}
