// Programa a2: uso del algoritmo transform()
// Fecha: 3/9/2019; 8:56 pm
// Revisin: 8/9/2020; 9:50 am
// S. Galliano.

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <array>
#include <cmath>
#include <numeric>

const int N = 10;
using namespace std;

// funcin para imprimir una lnea de valores
int mostrar(int x) {
    cout << setprecision(0) <<
    setw(3) << x            <<
    setw(8) << pow(x, 2)    <<
    setw(8) << pow(x, 3)    <<
    setprecision(4)         <<
    setw(10) << 1.0 / x     <<
    setw(10) << sqrt(x)     << '\n';
    return x;
}

int main() {
    cout << "Programa auxiliar 2: uso del transform()\n\nTabla de n\243meros.\n" <<
    //  encabezado
    setw(40) << setfill('-') << '\n' << setfill(' ') << fixed <<
    setw(3)  << "No"         <<
    setw(8)  << "Cuad"       <<
    setw(8)  << "Cubo"       <<
    setw(10) << "Inverso"    <<
    setw(10) << "Ra\241z"    << left <<
    setw(40) << setfill('-') << '\n' << setfill(' ') << right << '\n';

    int ary[N];
    iota(begin(ary), end(ary), 1); // llenado
    transform(begin(ary), end(ary), begin(ary), mostrar);
    cout << setw(40) << setfill('-') << '\n';
    system("pause");
    return EXIT_SUCCESS;
}
