// Programa 3: lmites de los nmeros reales.
// Fecha: 21/8/2019; 8:22 am
// S. Galliano.

#include <iostream>
#include <cstdlib>
#include <limits>

typedef std::numeric_limits<float>       lFlt;
typedef std::numeric_limits<double>      lDbl;
typedef std::numeric_limits<long double> lLdbl;

using std::numeric_limits;

int main() {
    std::cout
    << "Programa 3: caracter\241sticas de este sistema (2)\n\n"
    << "Base radix = " << lFlt::radix
    << "\nEstilo de redondeo: "; // el redondeo es nico

    switch (lLdbl::round_style) {
    case -1:
        std::cout << "indeterminado.";
        break;
    case 0:
        std::cout << "hacia cero.";
        break;
    case 1:
        std::cout << "al decimal m\240s pr\242ximo.";
        break;
    case 2:
        std::cout << "hacia infinito.";
        break;
    case 3:
        std::cout << "hacia infinito negativo.";
        break;
    } // switch

    std::cout
    << "\nError m\240ximo de redondeo: " << lFlt::round_error() << "\n"
    << "\nL\241mites de los valores en punto flotante:\n"
    << "\n float:"
    << "\n  precisi\242n decimal = " << lFlt::digits10
    << "\n  l\241mite de certeza = " << lFlt::epsilon()
    << "\n  valor m\240ximo = "      << lFlt::max()
    << "\n  valor m\241nimo = "      << lFlt::min()
    << "\n  exponente decimal m\240ximo = " << lFlt::max_exponent10
    << "\n  exponente decimal m\241nimo = " << lFlt::min_exponent10
    << "\n  exponente radix m\240ximo = "   << lFlt::max_exponent
    << "\n  exponente radix m\241nimo = "   << lFlt::min_exponent

    << "\n\n double:"
    << "\n  precisi\242n decimal = " << lDbl::digits10
    << "\n  l\241mite de certeza = " << lDbl::epsilon()
    << "\n  valor m\240ximo = "      << lDbl::max()
    << "\n  valor m\241nimo = "      << lDbl::min()
    << "\n  exponente decimal m\240ximo = " << lDbl::max_exponent10
    << "\n  exponente decimal m\241nimo = " << lDbl::min_exponent10
    << "\n  exponente radix m\240ximo = "   << lDbl::max_exponent
    << "\n  exponente radix m\241nimo = "   << lDbl::min_exponent

    << "\n\n long double:"
    << "\n  precisi\242n decimal = " << lLdbl::digits10
    << "\n  l\241mite de certeza = " << lLdbl::epsilon()
    << "\n  valor m\240ximo = "      << lLdbl::max()
    << "\n  valor m\241nimo = "      << lLdbl::min()
    << "\n  exponente decimal m\240ximo = " << lLdbl::max_exponent10
    << "\n  exponente decimal m\241nimo = " << lLdbl::min_exponent10
    << "\n  exponente radix m\240ximo = "   << lLdbl::max_exponent
    << "\n  exponente radix m\241nimo = "   << lLdbl::min_exponent
    << "\n\n";

    //  fin
    system("pause");
    return EXIT_SUCCESS;
}
