//  conversor.cpp: definiciones para el programa
//  Fecha: 23/2/2020; 9:18 am
//  Revisin: 28/3/2020; 1:34 pm
//  Por: S. Galliano.

#include "conversor.h"
#include <cctype>
#include <iostream>

//  convierte una letra del espaol a maysculas
char aMayusculas( char ch ) {
    if ( isalnum(ch) and islower(ch) ) { // slo minsculas ASCII
        ch = toupper( ch );
    }  else {
        if ( ch == '\201' ) ch = '\232'; else //   -> 
        if ( ch == '\202' ) ch = '\220'; else //   -> 
        if ( ch == '\240' ) ch = '\265'; else //   -> 
        if ( ch == '\241' ) ch = '\326'; else //   -> 
        if ( ch == '\242' ) ch = '\340'; else //   -> 
        if ( ch == '\243' ) ch = '\351'; else //   -> 
        if ( ch == '\244' ) ch = '\245';      //   -> 
    } // if
	
    return ch;
}

//  convierte una letra del espaol a minsculas
char aMinusculas ( char ch ) { // slo maysculas ASCII
    if ( isalnum(ch) and isupper(ch) ) {
        ch = tolower( ch );
    } else {
        if ( ch == '\220' ) ch = '\202'; else //   -> 
        if ( ch == '\232' ) ch = '\201'; else //   -> 
        if ( ch == '\245' ) ch = '\244'; else //   -> 
        if ( ch == '\265' ) ch = '\240'; else //   -> 
        if ( ch == '\326' ) ch = '\241'; else //   -> 
        if ( ch == '\340' ) ch = '\242'; else //   -> 
        if ( ch == '\351' ) ch = '\243';      //   -> 
    } // if
	
    return ch;
}
