// Programa 5: vectores
// Fecha: 12/4/2020; 1 pm
// Revisin: 8/9/2020; 10:40 am
// S. Galliano.

#include "vectores.h"
#include <iostream>
#include <cstdlib>
#include <cmath>
#include <iomanip>

const double RAD2GRAD = 45.0 / atan(1.0);
const int DEC = 2; // 2 decimales

int main() {
    std::cout << "Problema 5: c\240lculo del producto-punto de dos vectores\n\n";
    Vector A, B;

    // entradas
    A.entrar( "A" );
    B.entrar( "B" );
    std::cout << std::fixed << std::showpoint << std::setprecision( DEC ) << '\n';

    // calculos y salidas
    double pPto = A.pPunto( B );
    std::cout << "El producto-punto de A y B vale " << pPto << "\n\n";
    std::cout << "Norma de A = " << A.norma() << " u\n";
    std::cout << "Norma de B = " << B.norma() << " u\n";
    double sita = pPto / ( A.norma() * B.norma() );
    std::cout << "\nEl coseno entre A y B vale "      <<
    std::setprecision( DEC + 1 ) << sita << " rad o " <<
    std::setprecision( DEC )     << sita * RAD2GRAD   << " grados.\n";

    if( 0 == sita ) std::cout       << "A y B son perpendiculares.\n\n";
    else if( 1 == sita ) std::cout  << "A y B son paralelos.\n\n";
    else if( -1 == sita ) std::cout << "A y B son anti-paralelos.\n\n";
    else std::cout << '\n';

    system( "pause" );
    return EXIT_SUCCESS;
}
