#ifndef VECTORES_H_INCLUDED
#define VECTORES_H_INCLUDED

//  vectores.h: definiciones para el programa 5
//  Fecha: 12/4/2020; 1 pm
//  Por: S. Galliano.

#include <string>
typedef std::string Str;
#include <vector>
typedef std::vector<double> Vct;

//  un vector sabe como entrarse, mostrarse, calcular
//  su producto punto con otro vector y su norma
struct Vector {
    //  mtodos
    double pPunto( Vector B );
    void entrar( Str id );
    void mostrar( Str id );
    double norma();
    //  miembro
    Vct vect;
};

#endif // VECTORES_H_INCLUDED
