// Programa 6 El escalamiento.
// Fecha: 4/11/2019; 1:20 pm
// Revisin: 8/9/2020; 12:28 pm
// S. Galliano.

#include "../deposito/print.h"
#include "../deposito/varray.h"
#include "ops_es.h"
#include <iostream>
#include <cstdlib>
#include <iomanip>

const Str PRE( "c:/temp/bd/" ); // prefacio a los ficheros
const Str POS( ".txt" );         // adenda a los ficheros

int main() {
    std::cout << "Programa 6: creando tablas, una soluci\242n reutilizable.\n\n";
    Str archy; // la ID de los archivos a leer

    Str filas;//  fijando el archivo de materias
    std::cout << "\250Cu\240ntos alumnos? ";
    std::getline( std::cin, filas );
    archy = PRE + "materias" + filas + POS;  // ID completa
    Vct vMats;                               // vector de las materias

    try {
        vMats = cargarMaterias( archy );
    } catch( Str ) {
        std::cout << ERR;
        return EXIT_FAILURE;
    } // try-catch

    //  fijando el archivo de notas
    int cols = vMats.size();             // las columnas de la tabla
    int ancho = 8 * ( cols + 1 );        // el ancho por columna
    int fils = atoi( filas.c_str() );    // un entero para declarar el valarray
    archy = PRE + "notas" + filas + POS; // ID completa
    Val vAry( fils * cols );             // el arreglo de las notas

    try {
        vAry = cargarNotas( archy, ( fils * cols ) );
    } catch( Str ) {
        std::cout << ERR;
        return EXIT_FAILURE;
    } // try-catch

    // el clculo del promedio de cada alumno
    for( int i = 0; i < cols - 1; ++i ) {
        vAry[std::slice( cols - 1, fils, cols )] +=
            VA( vAry[std::slice( i, fils, cols )] ) / static_cast<double>( cols - 1 );
    } // for

    // todas las tablas de cualquier tamao
    std::cout << "\nTabla de resultados\n";
    ponerLinea( ancho );
    MUESTRA( vMats, "Asig." );
    std::cout << std::setprecision( 1 ) << std::fixed << '\n';
    ponerLinea( ancho, false );
    PRINTVA( vAry, cols, "Al. " ); // los promedios por alumno

    if( fils > 1 ) {  // particularizando a ms de un alumno -------------
        Val vp( cols ); // el arreglo de los promedios de las notas
        vp = tabular( vAry, fils, cols );
        ponerLinea( ancho, false );
        std::cout << "Prom.";
        PRINTVA( vp, cols - 1 );
    } // if --------------------------------------------------------------

    std::cout << '\n';
    ponerLinea( ancho ); // cierre de cualquier tabla
    system( "pause" );
    return EXIT_SUCCESS;
}
