#ifndef OPSES_H_INCLUDED
#define OPSES_H_INCLUDED

//  ops_es.h: definiciones para el programa 6
//  Fecha: 4/11/2019; 1:20 pm
//  Revisin: 8/9/2020; 12:28 pm
//  S. Galliano.

// pone una lnea doble por omisin, o simple, de tamao n en consola
// input: tamao
// output: lnea en consola
void ponerLinea( int n, bool doble = true );

#include <string>
typedef std::string Str;
const Str ERR( "El fichero no abri\242. Abortando.\n" );

#include <vector>
typedef std::vector<Str> Vct;

//  carga la BD de materias
//  input: el nombre del fichero
//  output: el vector
Vct cargarMaterias( Str archy );

#include <valarray>
typedef std::valarray<double> Val;

//  carga la BD de notas
//  input: el nombre del fichero y su tamao
//  output: los valores numricos
Val cargarNotas( Str archy, int n );

//  si la salida es una tabla, la pone en consola
//  input: el valarray y las filas y columnas de la tabla
//  output: la tabla est en consola
Val tabular( const Val & prom, int filas, int cols );

#endif // OPSES_H_INCLUDED
