// lse.cpp: definiciones para el programa 7
// Fecha: 13/4/2020; 7:27 pm
// Revisin: 8/9/2020; 1 pm
// Por: S. Galliano.
#include "lse.h"

Nodo::Nodo() { nodo.clear(); }

void Nodo::adiciona( int val, short pos ) {
    if( 0 == pos )
        nodo.push_front( val );
    else if( unsigned( pos ) > nodo.size() )
        nodo.push_back( val );
    else {
        Lst::iterator i = nodo.begin(); // iterador al inicio
        advance( i, pos - 1 );          // pone al ndice en posicin
        nodo.insert( i, val );          // se inserta
    } // if-en-cascada
}

#include <algorithm>

bool Nodo::enLista( int val ) { return find( nodo.begin(), nodo.end(), val ) != nodo.end(); }
