#ifndef MONEDAS_H_INCLUDED
#define MONEDAS_H_INCLUDED

// monedas.h: definiciones para el programa 7
// Fecha: 26/11/2019; 6:42 am
// Revisin: 8/9/2020; 5:10 pm
// S. Galliano

#include <string>
typedef std::string Str;
const Str ERR( "El fichero no abri\242. Abortando.\n" );

#include <map>
typedef std::multimap<Str, Str> Moneda;

//  carga la BD
//  input: el nombre del fichero
//  output: el mapa cargado
Moneda cargar( Str archy );

//  muestra los pases por moneda
//  input: el cdigo y el mapa
//  output: la respuesta en consola
void mostrar( Str iso, Str nombre, const Moneda & moneda );

#endif // MONEDAS_H_INCLUDED
