#ifndef ESTADS_H_INCLUDED
#define ESTADS_H_INCLUDED

//  entrada.h: declaraciones para el programa 16
//  Fecha: 26/8/2019; 7:52 am
//  Revisin: 11/9/2020; 12:22 pm
//  Por S. Galliano.

#include <ostream>
#include <string>
typedef std::string Str;
const Str ERROR( "\nNo pude abrir el archivo; abortando.\n" );
const int TAM = 200;

struct Estads {
    //  interfaz
    int suma         ();
    double mediana   ();
    int moda         ();
    double promedio  ();
    double varianza  ();
    double desviacion();
    int miMax        ();
    int miMin        ();
    void leerArchivo ( Str archy );
    // miembro
    int ary[TAM];
    int n;
};

//  flujos de salida especializados
void muestra( std::ostream & escribe, Str ID, const int & stat );
void muestra( std::ostream & escribe, Str ID, const double & stat );

//  funcin de comparacin
int compara( const void *p, const void *q );

#endif // ENTRADA_H_INCLUDED
