#ifndef AUXILIAR_H_INCLUDED
#define AUXILIAR_H_INCLUDED

//  auxiliar.h: declaraciones para el programa 13
//  Fecha: 25/8/2019; 12:47 m
//  Revisin: 11/9/2020; 9:11 am
//  Por S. Galliano.

#include <set>
#include <list>
#include <vector>
#include <array>

const int N = 500000;
typedef std::list<int>     lInt;
typedef std::vector<int>   vInt;
typedef std::array<int, N> aInt;
typedef std::multiset<int> sInt;

// funcin de comparacin de enteros
// input: dos vectores void
// output: 1 si *m > *n; -1 si *m < *n; 0 si *m == *n
int comparar( const void * m, const void * n );

#endif // AUXILIAR_H_INCLUDED
