// busca.cpp: definiciones para el programa 14
// Fecha: 21/1/2020; 8:50 a
// Revisin: 11/9/2020; 9:47 am
// Por: S. Galliano.

#include "busca.h"
#include <algorithm>
using std::pair;
using std::binary_search;
using std::equal_range;

//  busca las posiciones de los valores; la estrategia es
//  primero localizar si la clave est; luego localizar
//  dnde est y contar las veces que aparece
Par posiciones( int clave, Ary & ary ) {
    int lugar = 0, veces = 0; // de entrada no est

    if ( binary_search( ary.begin(), ary.end(), clave ) ) { // est?
        // los lmites donde est la clave
        pair<Ary::iterator, Ary::iterator>pos = equal_range( ary.begin(), ary.end(), clave );
        // devuelve el LUGAR (uno ms que el ndice) y las veces
        lugar = pos.first - ary.begin() + 1; // la posicin
        veces = pos.second - pos.first;      // las veces
    }

    return std::make_pair( lugar, veces );
}
