// Programa 14: bsqueda
// Fecha: 26/8/2019; 7 am
// Revisin: 11/9/2020; 9:47 am
// S. Galliano.

#include "../deposito/print.h"
#include "../deposito/rnd.h"
#include "busca.h"
#include <iostream>
#include <cstdlib>

int main() {
    using std::cout;
    cout <<
    "Programa 14: b\243squeda visual; si el valor est\240, dice "
    "cu\240ntas veces y d\242nde.\n\n";
    srand( time( nullptr ) ); // una semilla por ejecucin
    Ary ary;            // un arreglo STL
    int clave;          // el valor a buscar
    Par resp;           // las respuestas
    int m = 1, M = 100; // lmites - podran pedirse

    RELLENA_I( ary, m, M );              // la lista con valores azarosos
    std::sort( ary.begin(), ary.end() ); // la lista ordenada
    TABULA( ary, "Arreglo:\n\n" );       // su tabla a consola

    while ( true ) {
        cout << "T para terminar. \250Clave? ";
        std::cin >> clave;

        if ( std::cin.fail() )
            return EXIT_SUCCESS;

        if ( clave < 0 ) {
            cout << "Un entero positivo, por favor.\n";
            continue;
        } // if

        // resp.first: lugar; resp.second: veces
        resp = posiciones( clave, ary );

        if ( 0 == resp.second )
            cout << "No est\240\n\n";
        else
            ( 1 == resp.second )
                ? cout << "Est\240 una vez a partir de la posici\242n "
                       << resp.first << "\n\n"
                : cout << "Est\240 " << resp.second << " veces a partir de la posici\242n "
                       << resp.first << "\n\n";
    } // while
}
