// Programa 15: escribiendo a un archivo
// Fecha: 26/8/2019; 7:08 am
// Revisin: 11/9/2020; 10:21 am
// S. Galliano.

#include "../deposito/print.h"
#include "../deposito/rnd.h"
#include "salida.h"

const int N      = 200;                 // N nmeros
const short COLS = 10;                  // tabla de COLS columnas
const Str archy( "C:/temp/gauss.txt" ); // la salida - podra pedirse

int main() {
    std::cout <<
    "Programa 15: escribe " << N << " valores gaussianos\n"
    "en el archivo \"" << archy << "\"\n\n";
    Vct data( N );      // un vector de 200 dobles
    srand( time( 0 ) ); // una semilla aleatoria
    GAUSS( data );      // nmeros gaussianos normalizados

    try {
        alArchivo( archy, data );                      // se escriben a disco
        TABULA( data, "Valores:\n\n", 3, true, COLS ); // valores a consola
    } catch( Str ) {
        std::cerr << ERR;
        return EXIT_FAILURE;
    } // try-catch

    system( "pause" );
    return EXIT_SUCCESS;
}
