//  auxiliar.cpp: definiciones para el programa 19
//  Fecha: 13/6/2020; 2:39 pm
//  Revisin: 12/9/2020; 9:50 am
//  Por: S. Galliano.

#include "auxiliar.h"
#include "../deposito/print.h"
#include <iostream>

//  operacin de escritura para for_each
//  listas originales
void imprimirOriginal( const Lst & l ) {
    MUESTRA( l );
    std::cout << '\n';
}

//  listas ordenadas z->a
void imprimirOrdenada( Lst & l ) {
    l.sort( std::greater<int>() );
    imprimirOriginal( l );
}
